*---------------------------------------------------*
* Author : Domenick Ciccotto
* Date   : Fri  04-03-1992
* This Fuction will allow even a NOVICE programmer to do DATA driven STUFF
* The Code may be compiled in  S87 or 5.01
*---------------------------------------------------*
* MAIN Function Syntax :
*  CC_DataDrv(" Text File ", "Array Name1"  [,"Array Name2"] [,"Array Name3"] )
*    Use :  This function "CUTS UP" each line of the Text file and puts the
*    ALLTRIM of the UPPER of each substr() into an element of the named arrays.
*    Returns :   The number of lines (array Elements) in the text file.
*----------------------------------------*
*   Example of the first two lines of the Text File
*  " This text will be Array1[1] " |  " This text will be Array2[1] " | " This text will be Array3[1] "
*  " This text will be Array1[2] " |  " This text will be Array2[2] " | " This text will be Array3[2] "
*----------------------------------------*
* Note : The Quotes shown above are not needed. But are useful for menu Bars
*   where blank spaces may be needed before or after the array element.
*---------------*
* This function may be called as many times as you like, using different (or the same)
* Text files and array names.
* The Function also returns the number of lines (array Elements) in the text file.
* This may be useful for Auto ....  @ say  or  Prompt  placement.
* The minor functions  CC_ROW()  and  CC_COL()  can be used to take an
*  array element such as  12,22  ---->  POS[1]
*  and use it in a Auto placement menu.
* Example :   @CC_ROW(POS[1]),CC_COL(POS[1]) Prompt The_Prompt[1]
*-----------------------------------------------------------------------------*
* Another minor function is   CC_ASCAN()
* Syntax :  CC_ASCAN(" ARRAY NAME ", "Search String" [,Start Element])
* Same as   Clipper's   ASCAN()  ?????     in syntax ONLY
* CC_ASCAN()  returns the rest of the Element line.
* So if you make a  config type file, and one line has  "DEFAULT=D:\NETWORK"
* The first two line in you program could be .....
*     CC_DataDrv("CONFIG.TXT", "This_Node")
*     MEMVAR = CC_ASCAN("This_Node","DEFAULT=")
*
*     *****  MEMVAR is now equal to  D:\NETWORK *****
*-----------------------------------------------------------------------------*
* The following is a Demo of the CC_DataDrv() Function  and some Sub Functions
*-------------------======----------------------------------------------------*
set color to "+W/B"
********** Main Demo Menu *******************************
CC_DataDrv("DemoMenu.Txt","Prompt","Message","Run_This")
Do While .T.
 Set Message to 24
 Clear
 set color to I
 @0,0 Say " The Prompt is made up of Prompt[x]                                             "
 @1,0 Say " The message is Message[x] and the Program to run is Run_This[x]                "
 @2,0 say "   Hit <Esc.> to Abort Menu                                                     "
 @24,50 say "   Hit <Esc.> to Abort Menu   "
 set color to "+W/B"
 @6,13 to 18,55 Double
 set color to I
 @6,19 say " Data Taken From  DemoMenu.TxT "
 set color to "+W/B"

      @8,20  Prompt Prompt[1]   Message Message[1]
      @10,20 Prompt Prompt[2]   Message Message[2]
      @12,20 Prompt Prompt[3]   Message Message[3]
      @14,20 Prompt Prompt[4]   Message Message[4]
      @16,20 Prompt Prompt[5]   Message Message[5]
  Menu to _d_ccMenu
 If _d_ccMenu > 0
    dc_Do(Run_This[_d_ccMenu])
 Else
    Clear
    Exit
 EndIF
Enddo
************************************************* End of Main Menu Code





********** Demo *****************************************
Procedure Demo1

   A = CC_DataDrv("DCLIP.SYS","DOM1")
   set exact off
   Clear
   @0,0 say "**** Your dCLIP.sys File ( Only First 22 Lines )   ****"
   For I = 1 to A
     ? Ltrim(str(I)) + "  " + Dom1[I]
     If I = 22
        EXIT
     Endif
   Next
 Do While .T.
   store space(20) to aa
   @15,42 to 23,79 Double
   @16,43 say "Type the First part of any line and"
   @17,43 say " the rest of the line will appear."
   @19,44 say "Example :  PATH=       <Return>   "
   @18,44 get aa PICTURE "@!"
   Read
   @19,44 say "                                  "
   YY = LEN(ALLTRIM(AA))
   If Empty(aa)
      Exit
   EndIF
   zz = CC_ASCAN("DOM1",Alltrim(aa))
   @19,44 SAY ZZ
   @20,44 say "Line / Element "+ Ltrim(str(CC_Element))
   @21,45 say "Tap Space Bar to continue"
   inkey(0)
   @19,44 SAY SPACE(30)
   @20,44 say "                    "
   @21,45 say "Leave Blank to Exit       "
   @22,44 say "                    "
 Enddo
 Return


**************** Demo *****************************************
Procedure Demo2

  CC_DataDrv("TEST2.Txt","jim1","jim2")
  Clear
  @ CC_ROW(jim1[1]),CC_COL(jim1[1]) say jim2[1]
  @ CC_ROW(jim1[2]),CC_COL(jim1[2]) say jim2[2]

  Set Color to I
  @15,0 Clear
  @16,0 say "  The Following is the DATA TEXT FILE which was used .    TEST2.TXT            "
  @17,0 say ""
  For I = 1 to Line_cnt
    ? substr(Total_Line[I],1,79)
  Next
  Set color to "+W/B"
  inkey(0)
  return




************************************
*                                  *
*    The Code Shown Below          *
*     Makes up the Major           *
*     and Minor Functions          *
*                                  *
*                                  *
************************************

******************** Major  Function **************************************
 Function CC_DataDrv
 Parameters _d_cFile , _d_cArray1, _d_cArray2, _d_cArray3
   If pCOUNT() < 2
      ? " Missing Parameters "
      Return ""
   EndIF
   If pCOUNT() > 4
      ? " Too Many Parameters "
      Return ""
   EndIF
   nHandle = FOPEN(_d_cFile)
   IF FERROR() != 0
      ? "Error open file, error:", FERROR()
      TONE(200,4)
      wait " Press Any Key  "
      Return ""
   ELSE
      KK = MemoRead(_d_cFile)
      fclose(_d_cFile)
   ENDIF
   Public Line_Cnt
   Line_Cnt = MLcount(KK,160)
   If pCOUNT() > 3
      Release &_d_cARRAY3
      PUBLIC  &_d_cArray3[Line_Cnt]
   EndIF
   If pCOUNT() > 2
      Release &_d_cARRAY2
      PUBLIC  &_d_cArray2[Line_Cnt]
   EndIF
   Release &_d_cARRAY1
   PUBLIC  &_d_cArray1[Line_Cnt]
   Public Total_Line[Line_Cnt]    &&  <<<<<  Can change to declare
   Public Delim1,Delim2
   For Scr_Line = 1 to Line_Cnt
     Total_Line[Scr_Line] = UPPER(ALLTRIM(MemoLine(KK,160,Scr_Line)))  &&  was 80
     If EMPTY(Total_Line[Scr_Line])
        EXIT
     ENDIF
   Next

*---------------------*
* First Part of Line  *    <  Array #1  >
*---------------------*
      For Scr_Line = 1 to Line_Cnt
          If pCOUNT() > 2
             Delim1 = AT("|" , Total_Line[Scr_Line])
             Delim2 = Rat("|" , Total_Line[Scr_Line])
             ThisLen1 = Delim1 - 2
          Else
             ThisLen1 = Len(Total_Line[Scr_Line])
          EndIF

          If SUBSTR(Total_Line[Scr_Line],1,1) = CHR(34) .or. SUBSTR(Total_Line[Scr_Line],1,1) = CHR(39)
             &_d_cArray1[Scr_Line] = SUBSTR(Total_Line[Scr_Line],2,ThisLen1-1)
          Else
             &_d_cArray1[Scr_Line] = ALLTRIM(SUBSTR(Total_Line[Scr_Line],1,ThisLen1))
          ENDIF
          &_d_cArray1[Scr_Line] = Trim(&_d_cArray1[Scr_Line])
          ThisLen1 = Len(&_d_cArray1[Scr_Line])
          If SUBSTR(&_d_cArray1[Scr_Line],ThisLen1,1) = CHR(34) .or.  SUBSTR(&_d_cArray1[Scr_Line],ThisLen1,1) = CHR(39)
             &_d_cArray1[Scr_Line] = SUBSTR(&_d_cArray1[Scr_Line],1,ThisLen1-1)
          ENDIF
          If EMPTY(&_d_cArray1[Scr_Line])
             EXIT
          ENDIF
      Next

*----------------------*
* Second Part of Line  *    <  Array #2  >
*----------------------*
   IF pCOUNT() >2
      For Scr_Line = 1 to Line_Cnt
          Delim1 =  AT("|" , Total_Line[Scr_Line])
          If pCOUNT() > 3
             Delim2 = RAT("|" ,Total_Line[Scr_Line])
             ThisLen2 = (Delim2-1) - (Delim1+1)
          Else
             ThisLen2 = Len(Alltrim(Substr(Total_Line[Scr_Line],Delim1+1)))
          EndIF
          &_d_cArray2[Scr_Line] = Substr(Total_Line[Scr_Line],Delim1+1,ThisLen2)


           &_d_cArray2[Scr_Line] = AllTrim(&_d_cArray2[Scr_Line])
           If SUBSTR(&_d_cArray2[Scr_Line],1,1) = CHR(34) .or. SUBSTR(&_d_cArray2[Scr_Line],1,1) = CHR(39)
              &_d_cArray2[Scr_Line] = SUBSTR(&_d_cArray2[Scr_Line],2,ThisLen2)
           Else
              &_d_cArray2[Scr_Line] = ALLTRIM(SUBSTR(&_d_cArray2[Scr_Line],1,ThisLen2-1))
          ENDIF
          _d_cclen = Len(&_d_cArray2[Scr_Line])
          If SUBSTR(&_d_cArray2[Scr_Line],_d_cclen,1) = CHR(34) .or.  SUBSTR(&_d_cArray2[Scr_Line],_d_cclen,1) = CHR(39)
             &_d_cArray2[Scr_Line] = SUBSTR(&_d_cArray2[Scr_Line],1,_d_cclen-1)
          ENDIF
          If EMPTY(&_d_cArray2[Scr_Line])
             EXIT
          ENDIF
      Next
   ENDIF

*---------------------*
* Third Part of Line  *        <  Array #3  >
*---------------------*
   IF pCOUNT() >3
      For Scr_Line = 1 to Line_Cnt
          Delim1 =  AT("|" , Total_Line[Scr_Line])
          Delim2 = RAT("|" ,Total_Line[Scr_Line])
          ThisLen3 = Len(Total_Line[Scr_Line])-(Delim2-1)
          &_d_cArray3[Scr_Line] = Substr(Total_Line[Scr_Line],Delim2+1,ThisLen3)


           &_d_cArray3[Scr_Line] = AllTrim(&_d_cArray3[Scr_Line])
           If SUBSTR(&_d_cArray3[Scr_Line],1,1) = CHR(34) .or. SUBSTR(&_d_cArray3[Scr_Line],1,1) = CHR(39)
              &_d_cArray3[Scr_Line] = SUBSTR(&_d_cArray3[Scr_Line],2,ThisLen3)
           Else
              &_d_cArray3[Scr_Line] = ALLTRIM(SUBSTR(&_d_cArray3[Scr_Line],1,ThisLen3-1))
          ENDIF
          _d_cclen = Len(&_d_cArray3[Scr_Line])
          If SUBSTR(&_d_cArray3[Scr_Line],_d_cclen,1) = CHR(34) .or.  SUBSTR(&_d_cArray3[Scr_Line],_d_cclen,1) = CHR(39)
             &_d_cArray3[Scr_Line] = SUBSTR(&_d_cArray3[Scr_Line],1,_d_cclen-1)
          ENDIF
          If EMPTY(&_d_cArray3[Scr_Line])
             EXIT
          ENDIF
      Next
   ENDIF

  Return Line_Cnt

 *---------------------------------------
 Function CC_ROW
  Parameter Full_Str
  Return Val(Substr(Full_Str,1,2))

*---------------------------------------
 Function CC_COL
  Parameter Full_Str
  Return Val(Substr(Full_Str,4,2))
*---------------------------------------
*-----------------------------------------------------------------------------*
* Another minor function is   CC_ASCAN()
* Syntax :  CC_ASCAN(" ARRAY NAME ", "Search String" [,Start Element])
* Same as   Clipper's   ASCAN()  ?????     in syntax ONLY
* CC_ASCAN()  returns the rest of the Element line.
* So if you make a  config type file, and one line has
*    "DEFAULT=D:\NETWORK"
*--------*
* The first two line in you program could be .....
*     CC_DataDrv("CONFIG.TXT", "NETWORK")
*     MEMVAR = CC_ASCAN("NETWORK","DEFAULT=")
*
*     *****  MEMVAR is now equal to  D:\NETWORK *****
*-----------------------------------------------------------------------------*
 Function CC_ASCAN
   _d_ccASTART = 1
   Parameter  _d_ccArray,_d_ccSearch,_d_ccASTART
   Public CC_Element
   _d_ccLen = Len(_d_ccSearch)
   set exact off
   _d_cczz = aScan(&_d_ccArray,_d_ccSearch,_d_ccASTART)
   If _d_cczz = 0
      Return ""
   Endif
   CC_ELEMENT = _d_cczz
 Return  SUBSTR(&_d_ccArray[_d_ccZZ],_d_ccLen+1)
*-------------------------------------------------------------

